---
title: Add Account Custom Nameserver
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/typescript)

[Account Custom Nameservers](https://developers.cloudflare.com/api/typescript/resources/custom_nameservers)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Add Account Custom Nameserver

client.customNameservers.create(CustomNameserverCreateParams {account\_id, ns\_name, ns\_set } params, RequestOptionsoptions?): [CustomNameserver](<https://developers.cloudflare.com/api/typescript/resources/custom_nameservers#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)>) {dns\_records, ns\_name, status, 2 more }

POST/accounts/{account\_id}/custom\_ns

Adds a custom nameserver to the account for use as a vanity nameserver on zones.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account Settings Write`

##### ParametersExpand Collapse

<details>

<summary>

params: CustomNameserverCreateParams {account\_id, ns\_name, ns\_set }

</summary>

account\_id: string

Path param: Account identifier tag.

maxLength32

<a href="#(resource)%20custom_nameservers%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

ns\_name: string

Body param: The FQDN of the name server.

formathostname

<a href="#(resource)%20custom_nameservers%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ns_name">Link to this property</a>

ns\_set?: number

Body param: The number of the set that this name server belongs to.

maximum5

minimum1

<a href="#(resource)%20custom_nameservers%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ns_set">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_nameservers%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

CustomNameserver {dns\_records, ns\_name, status, 2 more }

A single account custom nameserver.

</summary>

<details>

<summary>

dns\_records: Array&lt;DNSRecord&gt;

A and AAAA records associated with the nameserver.

</summary>

<details>

<summary>

type?: "A"| "AAAA"

DNS record type.

</summary>

One of the following:

"A"

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20dns_records%20%3E%20(items)%20%3E%20(property)%20type%20%3E%20(member)%200">Link to this property</a>

"AAAA"

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20dns_records%20%3E%20(items)%20%3E%20(property)%20type%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20dns_records%20%3E%20(items)%20%3E%20(property)%20type">Link to this property</a>

value?: string

DNS record contents (an IPv4 or IPv6 address).

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20dns_records%20%3E%20(items)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20dns_records">Link to this property</a>

ns\_name: string

The FQDN of the name server.

formathostname

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20ns_name">Link to this property</a>

<details>

<summary>

Deprecatedstatus: "moved"| "pending"| "verified"

Verification status of the nameserver.

</summary>

One of the following:

"moved"

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%200">Link to this property</a>

"pending"

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%201">Link to this property</a>

"verified"

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20status">Link to this property</a>

zone\_tag: string

Identifier.

maxLength32

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20zone_tag">Link to this property</a>

ns\_set?: number

The number of the set that this name server belongs to.

maximum5

minimum1

<a href="#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)%20%3E%20(property)%20ns_set">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_nameservers%20%3E%20(model)%20custom_nameserver%20%3E%20(schema)>)

### Add Account Custom Nameserver

TypeScript

HTTPTypeScriptPythonGoTerraform

```
import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const customNameserver = await client.customNameservers.create({
  account_id: '372e67954025e0ba6aaa6d586b9e0b59',
  ns_name: 'ns1.example.com',
});

console.log(customNameserver.dns_records);
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "dns_records": [
      {
        "type": "A",
        "value": "1.1.1.1"
      }
    ],
    "ns_name": "ns1.example.com",
    "status": "verified",
    "zone_tag": "023e105f4ecef8ad9ca31a8372d0c353",
    "ns_set": 1
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "dns_records": [
      {
        "type": "A",
        "value": "1.1.1.1"
      }
    ],
    "ns_name": "ns1.example.com",
    "status": "verified",
    "zone_tag": "023e105f4ecef8ad9ca31a8372d0c353",
    "ns_set": 1
  }
}
```